#
# Sensus Consulting Ltd, Copyright 1997-1998
#
# Matt Newman <matt@sensus.org>
#

package require tk++

proc tk++::mkClass {class widget {baseClass tk++::Widget}} {
	#
	# Discover info about widget
	#
	if {[string match ::* $class]==0} {set class ::$class}

	$widget .tmp
	catch {.tmp __xxx__} methods
	set wOpts [.tmp configure]
	set wClass [winfo class .tmp]
	destroy .tmp

	regsub {^.*must be } $methods {} methods
	regsub -all { or } $methods { } methods
	regsub -all {, } $methods { } methods

	set wCmds {}
	foreach m $methods {
		if {$m == "cget" || $m == "configure"} continue
		lappend wCmds $m
	}
	#
	# Generate Class header
	#
	set options {}
	set itk_options {}
	foreach conf $wOpts {
		if {[llength $conf]!=5} continue
		lassign $conf opt resN resC defV

		lappend options $opt

		append itk_options [format {
	itk_option define %s %s %s %s
		} [list $opt] [list $resN] [list $resC] [list $defV]]
	}
	set body [format {
	inherit %s

	constructor {args} {
		#itk_option remove hull.background hull.cursor

		itk_component add widget {
			%s $itk_interior._
		} {
			keep %s
		}
		::pack $itk_component(widget) -expand yes -fill both

		::set wClass [winfo class $itk_component(widget)]

		[super]::bindtags $itk_component(widget) \
					replace 0 $wClass \
					itk-delete-$itk_interior $itk_interior [namespace current]
		[super]::bindtags $itk_interior \
					replace $itk_interior end \
					itk-hidden-$itk_interior

		::bind itk-hidden-${itk_interior} <FocusIn> {focus %%W._}

		::eval itk_initialize $args
	}
	protected method bindtags {w args} {
		if {$w == $itk_interior} {
			::set w $itk_component(widget)
		}
		return [eval [super]::bindtags $w $args]
	}
	} $baseClass $widget $options]
	# Add itk_options
	append body $itk_options
	# Add methods
	foreach cmd $wCmds {
		append body [format {
	public method %s {args} {
		::set cmd %s
		uplevel 1 $itk_component(widget) $cmd $args
	}
		} $cmd $cmd]
	}
	uplevel #0 [list class $class $body]

	set bindings {}
	foreach event [bind $wClass] {
		set script [bind $wClass $event]
		regsub -all {%W} $script {[tk++::path %W]} script
		append bindings [list bind $class $event $script]\n
	}
	uplevel #0 [list eval $bindings]
}
proc tk++::path {w} {
	if {[string match *._ $w]} {
		return [winfo parent $w]
	} else {
		return $w
	}
}
